/*
    Semplice coda (struttura FIFO)
*/

package NetNode ;

import java.util.Vector;

public class Queue {
  protected Vector queue;

  public Queue () {
    queue = new Vector ();
  }

  public synchronized Object remove () {
      while (queue.isEmpty ()) {
        try {
          wait ();
        } catch (InterruptedException ex) {
            ex.printStackTrace() ;
        }
      }
      Object item = queue.firstElement ();
      queue.removeElement (item);
      return item;
  }

  public synchronized void add (Object item) {     
      queue.addElement (item);
      notify ();
  }

  public boolean isEmpty () {
    return queue.isEmpty ();
  }

  public String toString() { return queue.toString() ; }
}

